"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Database = void 0;

var _postgres = _interopRequireDefault(require("postgres"));

var VerdaccioError = _interopRequireWildcard(require("@verdaccio/commons-api"));

var migrations = _interopRequireWildcard(require("./migrations"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function () { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

class Database {
  constructor(url) {
    _defineProperty(this, "_sql", void 0);

    _defineProperty(this, "ready", void 0);

    _defineProperty(this, "sql", async () => {
      try {
        await this.ready;
      } catch (err) {
        throw VerdaccioError.getServiceUnavailable(`[pg-storage/database]: can't get database ready with error ${err.message}`);
      }

      return this._sql;
    });

    _defineProperty(this, "initialize", async () => {
      await migrations.up(this._sql);
      return true;
    });

    this._sql = (0, _postgres.default)(url);
    this.ready = this.initialize();
  }

}

exports.Database = Database;