/// <reference types="node" />
import { ILocalPackageManager, Logger, Package } from '@verdaccio/types';
import { UploadTarball, ReadTarball } from '@verdaccio/streams';
import { Database } from './database';
export declare class PGPackageManager implements ILocalPackageManager {
    logger: Logger;
    private package;
    private tarball;
    constructor(database: Database, logger: Logger, storage: string, name: string);
    updatePackage: (arg1: string, arg2: Function, arg3: Function, arg4: Function, callback: (err: NodeJS.ErrnoException) => void) => void;
    deletePackage: (arg1: string, callback: (err: NodeJS.ErrnoException) => void) => void;
    removePackage: (callback: (err: NodeJS.ErrnoException) => void) => void;
    createPackage: (arg1: string, arg2: Package, callback: (err: NodeJS.ErrnoException) => void) => void;
    savePackage: (arg1: string, arg2: Package, callback: (err: NodeJS.ErrnoException) => void) => void;
    readPackage: (arg1: string, callback: (err: NodeJS.ErrnoException, result: Package) => void) => void;
    writeTarball: (name: string) => UploadTarball;
    readTarball: (name: string) => ReadTarball;
}
